'============================================================
' Projekt        : Setup-Steuerung mit Hilfe von Makros
' Modulname      : SETUP2.BAS
' Aufgabe        : Globale Deklarationen und Routinen
' Copyright      : Arthur Burda
' Compiler       : Visual Basic 3.0 fr Windows
'============================================================
' l. nderung am : 26.07.1994
' Version        : 1.00
' Bemerkungen    : Erste Implementierung
'------------------------------------------------------------
' l. nderung am : 24.09.1994
' Version        : 1.01
' Bemerkungen    : Neue Befehle: Kopiere_Datei_in_Win_Pfad
'                  und Entpacke_LHARC_EXE_in_Win_Pfad
'                  Balkenposition wird bei jedem Anzeigen des
'                  Statusfensters (Kopieren von Dateien) auf 0
'                  gesetzt.
'------------------------------------------------------------

Option Explicit

DefInt A-Z

'------------------------------------------------------------
' globale Konstanten
'------------------------------------------------------------

Global Const SRCCOPY = &HCC0020

'------------------------------------------------------------
' Typen
'------------------------------------------------------------

Type OFStruct
    cBytes As String * 1
    fFixedDisk As String * 1
    nErrCode As Integer
    reserved As String * 4
    szPathName As String * 128
End Type

Type ParamType
    i(10) As String
End Type

'------------------------------------------------------------
' globale Variablen
'------------------------------------------------------------

Global WinSysDir$ ' Windows-System-Verzeichnis
Global WinDir$ ' Windows-Verzeichnis
Global WinDrive$ ' Windows-Laufwerk
Global gfWin31%
Global gGroupName$ ' Name der Programmgruppe fr die Applikation

Global SetupIniName$ ' Name der Setup-INI-Datei inkl. Pfad (Standard: SETUP2.INI)

' Bereich [Global] (globale Parameter)

Global AppName$ ' Programmname (Standard: kein Name)
Global SetupName$ ' Name des Setup-Programms (Standard: SETUP)
Global WinSysNeeded& ' Anzahl Bytes fr Windows-Verzeichnisse (unkomprimiert)
Global OtherNeeded& ' Anzahl Bytes fr sonstige Dateien (unkomprimiert)
Global Compressed& ' Anzahl Bytes gesamt (komprimiert)
Global fOLE2% ' Gibt an, ob OLE 2.0 benutzt wird (Standard: N)

' Bereich [Setup-Fenster] (Hauptfenster des Setup-Programms)

Global SetupDlgTitle$ ' Setup-berschrift (Standard: keine berschrift)
Global TitleForeColor& ' Vordergrundfarbe der Setup-berschrift (Standard: &H80000005)
Global TitleFontBold% ' True, wenn die Setup-berschrift fett erscheinen soll (Standard: N)
Global TitleFontItalic% ' True, wenn die Setup-berschrift kursiv erscheinen soll (Standard: N)
Global TitleFontUnderline% 'True, wenn die Setup-berschrift unterstrichen erscheinen soll (Standard: N)
Global TitleFontName$ ' Name des Fonts fr Setup-berschrift (Standard: MS Sans Serif)
Global TitleFontSize# ' Gre des Fonts fr Setup-berschrift (Standard: 24)
Global SetupDlgBackColor& ' Hintergrundfarbe des Setup-Fensters (Standard: &H808000)
Global SetupDlgIntro$ ' Setup-Intro (Standard: kein Intro)
Global SetupIntroPosX% ' X-Position des Setup-Intro (Standard: 12)
Global SetupIntroPosY% ' Y-Position des Setup-Intro (Standard: 80)
Global SetupIntroWidth% ' Breite des Setup-Intro (Standard: 609)
Global SetupIntroHeight% ' Hhe des Setup-Intro (Standard: 353)

' Bereich [Message-Boxen] (Parameter fr Message-Boxen)

Global ErrorBoxCaption$ ' Kopfzeile fr Fehler-Box (Standard: Fehler)
Global CrErrorBoxCaption$ ' Kopfzeile fr Kritischer-Fehler-Box (Standard: Kritischer Fehler)
Global InfoBoxCaption$ ' Kopfzeile fr Info-Box (Standard: Hinweis)
Global QuestionBoxCaption$ ' Kopfzeile fr Frage-Box (Standard: Frage)
Global WarningBoxCaption$ ' Kopfzeile fr Warnung-Box (Standard: Warnung)

' Bereich [Status-Fenster] (Parameter fr das Status-Dialogfenster)

Global StatusTitle$ ' Kopfzeile fr das Status-Fenster (Standard: Status)

' Bereich [Installation von] (Angabe des Quellpfades und anderer fr die Installation wichtiger Parameter)

Global SrcDialogTitle$ ' Dialog-Kopfzeile (Standard: Installation von ...)
Global SrcDialogInfo$ ' Info (Standard: Bitte geben Sie Laufwerk und Pfad ein, in dem sich das zu installierende Programm befindet.)
Global SrcPathLabel$ ' Beschriftung fr das Textfeld (Standard: Quellpfad:)
Global SrcDrive$ ' Quell-Laufwerksbezeichnung (Standard: A:)
Global SrcPath$ ' Quellpfad (ohne Laufwerksangabe, z.B. \TEST)

' Bereich [Installation nach] (Angabe des Zielpfades und anderer fr die Installation wichtiger Parameter)

Global DestDialogTitle$ ' Dialog-Kopfzeile (Standard: Installation nach ...)
Global DestDialogInfo$ ' Info (Standard: Bitte geben Sie Laufwerk und Pfad ein, wonach das Programm installiert werden soll.)
Global DestPathLabel$ ' Beschriftung fr das Textfeld (Standard: Zielpfad:)
Global DestDrive$ ' Ziel-Laufwerksbezeichnung (Standard: C:)
Global DestPath$ ' Zielpfad (ohne Laufwerksangabe, z.B. \TEST)

Global position ' Position des Statusbalkens beim Kopieren von Dateien (in %)

'------------------------------------------------------------
' Deklaration der API-Funktionen
'------------------------------------------------------------

Declare Function GetWindowsDirectory Lib "Kernel" (ByVal lpBuffer As String, ByVal nSize As Integer) As Integer
Declare Function GetSystemDirectory Lib "Kernel" (ByVal lpBuffer As String, ByVal nSize As Integer) As Integer
Declare Function BitBlt Lib "Gdi" (ByVal destHdc, ByVal x, ByVal y, ByVal w, ByVal h, ByVal srcHdc, ByVal srcX, ByVal srcY, ByVal Rop As Long)
Declare Function GetVersion Lib "Kernel" () As Long

Declare Function DiskSpaceFree Lib "SETUPKIT.DLL" () As Long
Declare Function AllocUnit Lib "SETUPKIT.DLL" () As Long
Declare Function SetTime Lib "SETUPKIT.DLL" (ByVal A$, ByVal B$) As Integer

Declare Function VerInstallFile& Lib "ver.dll" (ByVal Flags%, ByVal SrcFile$, ByVal DestFile$, ByVal SrcPath$, ByVal DestPath$, ByVal CurrDir$, ByVal TmpFile$, lpwTmpFileLen%)
Declare Function GetFileVersionInfoSize Lib "ver.dll" (ByVal lpszFileName As String, lpdwHandle As Long) As Long
Declare Function GetFileVersionInfo Lib "ver.dll" (ByVal lpszFileName As String, ByVal lpdwHandle As Long, ByVal cbbuf As Long, ByVal lpvdata As String) As Integer
Declare Function VerQueryValue Lib "ver.dll" (ByVal lpvBlock As String, ByVal lpszSubBlock As String, lplpBuffer As Long, lpcb As Integer) As Integer
Declare Function lstrcpyn Lib "Kernel" (ByVal lpszString1 As Any, ByVal lpszString2 As Long, ByVal cChars As Integer) As Long

Declare Function WritePrivateProfileString% Lib "Kernel" (ByVal lpAppName$, ByVal lpKeyName$, ByVal lpString$, ByVal lpFileName$)
Declare Function GetPrivateProfileString Lib "Kernel" (ByVal lpAppName$, ByVal lpKeyName$, ByVal lpDefault$, ByVal lpRetString$, ByVal nSize%, ByVal lpFileName$) As Integer

Declare Function OpenFile Lib "Kernel" (ByVal lpFileName As String, lpReOpenBuff As OFStruct, ByVal wStyle As Integer) As Integer

Declare Function GetModuleUsage Lib "Kernel" (ByVal hModule As Integer) As Integer

Declare Function GetModuleHandle Lib "KERNEL" (ByVal ModuleName As String) As Integer
Declare Function Ctl3DAutoSubclass Lib "CTL3D.DLL" (ByVal hInst As Integer) As Integer
Declare Function Ctl3DRegister Lib "CTL3D.DLL" (ByVal hInst As Integer) As Integer
Declare Function Ctl3DUnregister Lib "CTL3D.DLL" (ByVal hInst As Integer) As Integer

'============================================================
' Routine : AddShare
'============================================================
' Aufgabe : Fgt den SHARE-Befehl in die Datei AUTOEXEC.BAT ein
'           (falls nicht vorhanden) und liefert True bzw. False
'           zurck.
' Eingabe : DosPath = DOS-Pfad
'           Param   = SHARE-Parameter
' Ausgabe : keine
' Return  : True bzw. False (True wird auch bei Vorhandensein
'           des SHARE-Befehls zurckgeliefert)
'------------------------------------------------------------
'
Function AddShare (DosPath$, Param$) As Integer

    Dim f1, f2
    Dim found
    Dim ln$

    On Error GoTo ERR_AddShare

    AddShare = False

    found = False

    f1 = FreeFile
    Open "C:\AUTOEXEC.BAT" For Input As f1
    While Not EOF(f1)
	Line Input #f1, ln$
	If InStr(1, UCase$(ln$), "REM") = 0 And InStr(1, ln$, ";") = 0 And InStr(1, UCase$(ln$), "SHARE") > 0 Then
	    found = True
	End If
    Wend
    Close #f1

    If Not found Then
	FileCopy "C:\AUTOEXEC.BAT", "C:\AUTOEXEC.$$$"
	f1 = FreeFile
	Open "C:\AUTOEXEC.BAT" For Output As f1
	f2 = FreeFile
	Open "C:\AUTOEXEC.$$$" For Input As f2
	If DosPath$ = "" Then
	    If Param$ = "" Then
		Print #f1, "SHARE.EXE"
	    Else
		Print #f1, "SHARE.EXE " & Param$
	    End If
	Else
	    If Param$ = "" Then
		Print #f1, DosPath$ & "\SHARE.EXE"
	    Else
		Print #f1, DosPath$ & "\SHARE.EXE " & Param$
	    End If
	End If
	While Not EOF(f2)
	    Line Input #f2, ln$
	    Print #f1, ln$
	Wend
	Close #f1
	Close #f2
	If Err = 0 Then
	    Kill "C:\AUTOEXEC.$$$"
	    AddShare = True
	End If
    Else
	AddShare = True
    End If

EXIT_AddShare:

    Exit Function

ERR_AddShare:

    Close #f1
    Close #f2
    If FileExists("C:\AUTOEXEC.$$$") Then
	Kill "C:\AUTOEXEC.BAT"
	Name "C:\AUTOEXEC.$$$" As "AUTOEXEC.BAT"
    End If
    AddShare = False
    GoTo EXIT_AddShare

End Function

'============================================================
' Routine : CenterForm
'============================================================
' Aufgabe : Zentriert eine Form auf dem Bildschirm.
' Eingabe : f = Form
' Ausgabe : keine
'------------------------------------------------------------
'
Sub CenterForm (f As Form)

    Screen.MousePointer = 11
    f.Top = (Screen.Height * .95) / 2 - f.Height / 2
    f.Left = Screen.Width / 2 - f.Width / 2
    Screen.MousePointer = 0

End Sub

'============================================================
' Routine : ConcatSplitFiles
'============================================================
' Aufgabe : Fgt Split-Dateien zu einer Datei zusammen.
' Eingabe : firstfile = Name der ersten Split-Datei
'           cSplit    = Anzahl der Split-Dateien
' Ausgabe : keine
'------------------------------------------------------------
'
Sub ConcatSplitFiles (firstfile$, cSplit%)

    Dim x%, fh1%, fh2%, outfile$, outfileLen&, CopyLeftOver&, CopyChunk#, filevar$
    Dim iFileMax%, iFile%, y%

    For x% = 2 To cSplit%

	fh1% = FreeFile
	Open Left$(firstfile$, Len(firstfile$) - 1) + Format$(1) For Binary As fh1%
	
	fh2% = FreeFile
	outfile$ = Left$(firstfile$, Len(firstfile$) - 1) + Format$(x%)
	Open outfile$ For Binary As fh2%
    
	Seek #fh1%, LOF(fh1%) + 1

	outfileLen& = LOF(fh2%)
	CopyLeftOver& = outfileLen& Mod 10
	CopyChunk# = (outfileLen& - CopyLeftOver&) / 10
	filevar$ = String$(CopyLeftOver&, 32)
	Get #fh2%, , filevar$
	Put #fh1%, , filevar$
	filevar$ = String$(CopyChunk#, 32)
	iFileMax% = 10

	For iFile% = 1 To iFileMax%
	    Get #fh2%, , filevar$
	    Put #fh1%, , filevar$
	Next iFile%

	Close fh1%, fh2%
	y% = SetTime(outfile$, firstfile$)
	Kill outfile$

    Next x%

    FileCopy Left$(firstfile$, Len(firstfile$) - 1) + Format$(1), firstfile$
    Kill Left$(firstfile$, Len(firstfile$) - 1) + Format$(1)

End Sub

'============================================================
' Routine : CopyFile
'============================================================
' Aufgabe : Kopiert die Datei SrcFileName (Pfad SourcePath)
'           nach DestFileName (Pfad DestPath) und liefert True
'           bzw. False zurck, je nachdem, ob der Kopiervor-
'           gang erfolgreich war oder nicht.
' Eingabe : SourcePath      = Quellpfad
'           DestinationPath = Zielpfad
'           SrcFileName     = Name der Quelldatei
'           DestFileName    = Name der Zieldatei
' Ausgabe : keine
' Return  : True (Kopiervorgang erfolgreich) oder False (Ko-
'           piervorgang milungen)
'------------------------------------------------------------
'
Function CopyFile (ByVal SourcePath As String, ByVal DestinationPath As String, ByVal SrcFilename As String, ByVal DestFileName As String) As Integer

    Const VIFF_FORCEINSTALL% = &H1, VIFF_DONTDELETEOLD% = &H2
    Const OF_DELETE% = &H200
    Const VIF_TEMPFILE& = &H1
    Const VIF_MISMATCH& = &H2
    Const VIF_SRCOLD& = &H4

    Const VIF_DIFFLANG& = &H8
    Const VIF_DIFFCODEPG& = &H10
    Const VIF_DIFFTYPE& = &H20
    Const VIF_WRITEPROT& = &H40
    Const VIF_FILEINUSE& = &H80
    Const VIF_OUTOFSPACE& = &H100
    Const VIF_ACCESSVIOLATION& = &H200
    Const VIF_SHARINGVIOLATION = &H400
    Const VIF_CANNOTCREATE = &H800
    Const VIF_CANNOTDELETE = &H1000
    Const VIF_CANNOTRENAME = &H2000
    Const VIF_CANNOTDELETECUR = &H4000
    Const VIF_OUTOFMEMORY = &H8000

    Const VIF_CANNOTREADSRC = &H10000
    Const VIF_CANNOTREADDST = &H20000

    Const VIF_BUFFTOOSMALL = &H40000

    Dim TmpOFStruct As OFStruct
    Dim x%
    Dim CurrDir$
    Dim TmpFile$
    Dim lpwTempFileLen%
    Dim InFileVer$
    Dim OutFileVer$
    Dim Result&
    Dim s$
    Dim TryAgain%
    Dim copyresult%

    On Error GoTo ERR_CopyFile

    Screen.MousePointer = 11

    If Right$(SourcePath$, 1) <> "\" Then
	SourcePath$ = SourcePath$ + "\"
    End If

    If Right$(DestinationPath$, 1) <> "\" Then
	DestinationPath$ = DestinationPath$ + "\"
    End If

    If FileExists(DestinationPath$ & DestFileName$) Then
	If ShowYesNoBox(QuestionBoxCaption$, "Datei " & DestinationPath$ & DestFileName$ & " exitiert bereits." & Chr$(13) & "berschreiben?", 1) = IDNO Then
	    UpdateStatus GetFileSize(SourcePath$ + SrcFilename$)
	    CopyFile = True
	    GoTo EXIT_CopyFile
	End If
    End If

    frm_StatusDlg.lab_SourceFile.Caption = UCase$(SourcePath$ + SrcFilename$)
    frm_StatusDlg.lab_SourceFile.Refresh
    frm_StatusDlg.lab_DestFile.Caption = UCase$(DestinationPath$ + DestFileName$)
    frm_StatusDlg.lab_DestFile.Refresh

CheckForExist:

    If Not FileExists(SourcePath$ + SrcFilename$) Then
	
	Screen.MousePointer = 0
	x% = ShowErrorBox("Folgende Datei konnte nicht gefunden werden: " + SourcePath$ + SrcFilename$, 1)
	Screen.MousePointer = 11

	If x% = 3 Then
	    CopyFile = False
	ElseIf x% = 4 Then
	    GoTo CheckForExist
	ElseIf x% = 5 Then
	    GoTo EXIT_CopyFile
	End If

    Else

TryToCopyAgain:
    
	CurrDir$ = String$(255, 0)
	TmpFile$ = String$(255, 0)
	lpwTempFileLen% = 255
	InFileVer$ = GetFileVersion(SourcePath$ + SrcFilename$)
	OutFileVer$ = GetFileVersion(DestinationPath$ + DestFileName$)

	If Len(InFileVer$) <> 0 And Len(OutFileVer$) <> 0 Then
	    If InFileVer$ <= OutFileVer$ And SourcePath <> DestinationPath Then
		UpdateStatus GetFileSize(SourcePath$ + SrcFilename$)
		CopyFile = True
		GoTo EXIT_CopyFile
	    End If
	End If

	Result& = VerInstallFile&(0, SrcFilename$, DestFileName$, SourcePath$, DestinationPath$, CurrDir$, TmpFile$, lpwTempFileLen%)

	s$ = DestinationPath$
	If Right$(s$, 1) <> "\" Then s$ = s$ + "\"
	s$ = s$ + DestFileName$
	If Not TryAgain% Then UpdateStatus GetFileSize(s$)

	If Result& = 0 Or (Result& And VIF_SRCOLD&) = VIF_SRCOLD& Then
	    CopyFile = True
	ElseIf (Result& And VIF_DIFFLANG&) = VIF_DIFFLANG& Then
	    Result& = VerInstallFile&(VIFF_FORCEINSTALL%, SrcFilename$, DestFileName$, SourcePath$, DestinationPath$, CurrDir$, TmpFile$, lpwTempFileLen%)
	    CopyFile = True
	ElseIf (Result& And VIF_DIFFTYPE&) = VIF_DIFFTYPE& Then
	    Result& = VerInstallFile&(VIFF_FORCEINSTALL%, SrcFilename$, DestFileName$, SourcePath$, DestinationPath$, CurrDir$, TmpFile$, lpwTempFileLen%)
	    CopyFile = True
	ElseIf (Result& And VIF_WRITEPROT&) = VIF_WRITEPROT& Then
	    Result& = VerInstallFile&(VIFF_FORCEINSTALL%, SrcFilename$, DestFileName$, SourcePath$, WinSysDir$ + "\", CurrDir$, TmpFile$, lpwTempFileLen%)
	    CopyFile = True
	ElseIf (Result& And VIF_CANNOTREADSRC) = VIF_CANNOTREADSRC Then
	    FileCopy SourcePath$ + SrcFilename$, DestinationPath$ + DestFileName$
	    CopyFile = True
	Else
	    Screen.MousePointer = 0
	    If (Result& And VIF_FILEINUSE&) = VIF_FILEINUSE& Then
		x% = ShowErrorBox(DestFileName$ & " wird schon benutzt. Bitte beenden Sie alle Programme und fhren Setup nochmal aus.", 1)
		If x% = 3 Then
		    CopyFile = False
		ElseIf x% = 4 Then
		    TryAgain% = True
		    GoTo TryToCopyAgain
		ElseIf x% = 5 Then
		    CopyFile = True
		    GoTo EXIT_CopyFile
		End If
	    Else
		ShowErrorBox2 DestFileName$ & " kann nicht installiert werden."
		CopyFile = False
	    End If
	    Screen.MousePointer = 11
	End If

	If (Result& And VIF_TEMPFILE&) = VIF_TEMPFILE& Then copyresult% = OpenFile(TmpFile$, TmpOFStruct, OF_DELETE%)
	Screen.MousePointer = 0
	GoTo EXIT_CopyFile

    End If

EXIT_CopyFile:

    Exit Function

ERR_CopyFile:

    CopyFile = False
    Screen.MousePointer = 0
    Exit Function

End Function

'============================================================
' Routine : CreatePath
'============================================================
' Aufgabe : Erstellt ein neues Verzeichnis und liefert True
'           bzw. False zurck, je nachdem, ob die Operation
'           erfolgreich war oder nicht.
' Eingabe : DestinationPath = Verzeichnisname
' Ausgabe : keine
' Return  : True bzw. False
'------------------------------------------------------------
'
Function CreatePath (DestinationPath$) As Integer

    Dim BackPos, ForePos
    Dim temp$

    Screen.MousePointer = 11

    If Right$(DestinationPath$, 1) <> "\" Then
	DestinationPath$ = DestinationPath$ + "\"
    End If
    
    On Error Resume Next

    ChDrive DestinationPath$
    If Err <> 0 Then GoTo ERR_CreatePath
    ChDir "\"

    BackPos = 3
    ForePos = InStr(4, DestinationPath$, "\")
    Do While ForePos <> 0
	temp$ = Mid$(DestinationPath$, BackPos + 1, ForePos - BackPos - 1)
	Err = 0
	MkDir temp$
	If Err <> 0 And Err <> 75 Then GoTo ERR_CreatePath
	Err = 0
	ChDir temp$
	If Err <> 0 Then GoTo ERR_CreatePath
	BackPos = ForePos
	ForePos = InStr(BackPos + 1, DestinationPath$, "\")
    Loop
	
    CreatePath = True
    Screen.MousePointer = 0
    
EXIT_CreatePath:

    Exit Function
	
ERR_CreatePath:

    ShowErrorBox2 "Pfad " & Left$(DestinationPath$, Len(DestinationPath$) - 1) & " konnte nicht erstellt werden."
    CreatePath = False
    Screen.MousePointer = 0

End Function

'============================================================
' Routine : CreateProgManGroup
'============================================================
' Aufgabe : Erzeugt eine neue Programmgruppe.
' Eingabe : f         = Form, in der das Steuerelement lab_1
'                       enthalten ist
'           GroupName = Name der Programmgruppe
'           GroupPath = String, der den Namen der Gruppendatei
'                       enthlt
' Ausgabe : keine
'------------------------------------------------------------
'
Sub CreateProgManGroup (f As Form, groupname$, GroupPath$)

    Dim i%
    Dim z%

    Screen.MousePointer = 11

    On Error Resume Next
    
    f.lab_1.LinkTopic = "ProgMan|Progman"
    f.lab_1.LinkMode = 2

    For i% = 1 To 10
	z% = DoEvents()
    Next

    f.lab_1.LinkTimeout = 100
    f.lab_1.LinkExecute "[CreateGroup(" + groupname$ + Chr$(44) + GroupPath$ + ")]"
    gGroupName = groupname
    f.lab_1.LinkTimeout = 50
    f.lab_1.LinkMode = 0

    Screen.MousePointer = 0

End Sub

'============================================================
' Routine : CreateProgManItem
'============================================================
' Aufgabe : Erzeugt einen neuen Eintrag in der aktuellen Prog-
'           rammgruppe.
' Eingabe : f         = Form, in der das Steuerelement lab_1
'                       enthalten ist
'           CmdLine   = String, der die Kommandozeile fr den
'                       Eintrag/Icon enthlt
'           IconTitle = Text unter dem Icon
' Ausgabe : keine
'------------------------------------------------------------
'
Sub CreateProgManItem (f As Form, CmdLine$, IconTitle$)

    Dim i%
    Dim z%

    Screen.MousePointer = 11

    On Error Resume Next
    
    f.lab_1.LinkTopic = "ProgMan|Progman"
    f.lab_1.LinkMode = 2

    For i% = 1 To 10
	z% = DoEvents()
    Next
    
    f.lab_1.LinkTimeout = 100
    If gfWin31% Then
	f.lab_1.LinkExecute "[ReplaceItem(" + IconTitle$ + ")]"
    End If
    f.lab_1.LinkExecute "[AddItem(" + CmdLine$ + Chr$(44) + IconTitle$ + Chr$(44) + ",,)]"
    f.lab_1.LinkExecute "[ShowGroup(" + gGroupName + ", 1)]"
    f.lab_1.LinkTimeout = 50
    f.lab_1.LinkMode = 0

    Screen.MousePointer = 0

End Sub

'============================================================
' Routine : DoneCtl3D
'============================================================
' Aufgabe : Deinstalliert die Windows-Klasse zur 3D-Darstellung
'           von Message-Boxen und liefert True oder False zu-
'           rck, je nachdem, ob die Operation erfolgreich war
'           oder nicht.
' Eingabe : ProgName = Name des Programms
' Ausgabe : keine
' Return  : True oder False
'------------------------------------------------------------
'
Function DoneCtl3D (ProgName$) As Integer

    Dim Inst%, Result%

    On Error Resume Next

    DoneCtl3D = False
    Inst% = GetModuleHandle(ProgName)
    Result% = Ctl3DUnregister(Inst%)
    DoneCtl3D = Result%

End Function

'============================================================
' Routine : EndProgram
'============================================================
' Aufgabe : Beendet das Setup-Programm.
' Eingabe : Info = Info-Text anzeigen (True oder False)
' Ausgabe : keine
'------------------------------------------------------------
'
Sub EndProgram (Info%)

    If Info Then
	If AppName$ = "" Then
	    ShowInfoBox "Die Anwendung wurde nicht richtig installiert. Rufen Sie das Setup-Programm erneut auf."
	Else
	    ShowInfoBox AppName$ & " wurde nicht richtig installiert. Rufen Sie das Setup-Programm erneut auf."
	End If
    End If
    ChDrive WinDrive$
    ChDir Left$(WinDir$, Len(WinDir$) - 1)
    End

End Sub

'============================================================
' Routine : ExecCmd
'============================================================
' Aufgabe : Fhrt einen Installationsbefehl mit Parametern aus
'           und liefert True oder False, je nachdem, ob die
'           Operation erfolgreich war oder nicht.
' Eingabe : Cmd   = Befehl
'           Param = Parameter (max. 10)
'           Count = Lfd-Nr.
'           Item  = Eintrag (Kommando mit Parametern)
' Ausgabe : keine
' Return  : True oder False
'------------------------------------------------------------
'
Function ExecCmd (Cmd$, Param As ParamType, Count%, Item$) As Integer

    Dim OutButton$
    Dim temp1$, temp2$
    Dim v1 As Variant, v2 As Variant
    Dim WinSpaceFree&, DestSpaceFree&
    Dim TotalNeeded&
    Dim Result%
    Dim CurrDir$

    ExecCmd = False

    Select Case Cmd$

	' Syntax: [Lfd-Nr]=Eingabe_Quellpfad

	Case UCase$("Eingabe_Quellpfad")

	    ShowPathDialog SrcDialogTitle$, SrcDialogInfo$, SrcPathLabel$, SrcDrive$, SrcPath$, SrcPath$, OutButton$
	    If OutButton$ = "Exit" Then
		EndProgram False
	    Else
		If Left$(SrcPath$, 1) = "\" Then
		    SrcPath$ = SrcDrive$ + SrcPath$
		ElseIf Len(SrcPath$) > 2 Then
		    If InStr(1, SrcPath$, ":") And InStr(2, SrcPath$, "\") Then
			SrcDrive$ = UCase$(Left$(SrcPath$, 2))
		    End If
		End If
		SrcPath$ = UCase$(SrcPath$)
	    End If

	' Syntax: [Lfd-Nr]=Eingabe_Zielpfad

	Case UCase$("Eingabe_Zielpfad")

	    ShowPathDialog DestDialogTitle$, DestDialogInfo$, DestPathLabel$, DestDrive$, DestPath$, DestPath$, OutButton$
	    If OutButton$ = "Exit" Then
		EndProgram False
	    Else
		If Left$(DestPath$, 1) = "\" Then
		    DestPath$ = DestDrive$ + DestPath$
		ElseIf Len(DestPath$) > 2 Then
		    If InStr(1, DestPath$, ":") And InStr(2, DestPath$, "\") Then
			DestDrive$ = UCase$(Left$(DestPath$, 2))
		    End If
		End If
		DestPath$ = UCase$(DestPath$)
	    End If

	' Syntax: [Lfd-Nr]=Zeige_Info [Kopfzeile]; [Message]; [Warte-Sekunden]

	Case UCase$("Zeige_Info")

	    If Param.i(3) = "" Then Param.i(3) = "5"
	    ShowMessageDialog Param.i(1), Param.i(2)
	    v1 = 0
	    v2 = CVar(Param.i(3))
	    temp1$ = Time$
	    While CInt(v1) < CInt(v2)
		temp2$ = Time$
		If temp1$ <> temp2$ Then
		    temp1$ = temp2$
		    v1 = v1 + 1
		End If
	    Wend
	    Unload frm_MessageDlg

	' Syntax: [Lfd-Nr]=Prfe_Speicherplatz

	Case UCase$("Prfe_Speicherplatz")

	    WinSpaceFree& = GetDiskSpaceFree(WinDrive$)
	    DestSpaceFree& = GetDiskSpaceFree(DestDrive$)

	    TotalNeeded& = WinSysNeeded& + OtherNeeded&

	    If DestSpaceFree& < TotalNeeded& Then
		ShowErrorBox2 "Nicht genug Speicherplatz auf Laufwerk " & DestDrive$ & Chr$(13) & Chr$(13) & "Es fehlen " & LTrim$(RTrim$(Str$(TotalNeeded& - DestSpaceFree&))) & " Bytes." & Chr$(13) & Chr$(13) & "Verschaffen Sie sich den erforderlichen Speicherplatz und rufen Sie das Setup-Programm erneut auf."
		GoTo ERR_ExecCmd_1
	    End If
	    If WinSpaceFree& < WinSysNeeded& Then
		ShowErrorBox2 "Nicht genug Speicherplatz auf Laufwerk " & WinDrive$ & Chr$(13) & Chr$(13) & "Es fehlen " & LTrim$(RTrim$(Str$(WinSysNeeded& - WinSpaceFree&))) & " Bytes." & Chr$(13) & Chr$(13) & "Verschaffen Sie sich den erforderlichen Speicherplatz und rufen Sie das Setup-Programm erneut auf."
		GoTo ERR_ExecCmd_1
	    End If
	    If DestSpaceFree& < OtherNeeded& Then
		ShowErrorBox2 "Nicht genug Speicherplatz auf Laufwerk " & DestDrive$ & Chr$(13) & Chr$(13) & "Es fehlen " & LTrim$(RTrim$(Str$(OtherNeeded& - DestSpaceFree&))) & " Bytes." & Chr$(13) & Chr$(13) & "Verschaffen Sie sich den erforderlichen Speicherplatz und rufen Sie das Setup-Programm erneut auf."
		GoTo ERR_ExecCmd_1
	    End If

	' Syntax: [Lfd-Nr]=Disk_Anforderung [Disk-Nr]; [Identifikations-Dateiname]

	Case UCase$("Disk_Anforderung")

	    If Param.i(1) = "" Then
		ShowErrorBox2 "Fehler in der Setup-INI-Datei " & SetupIniName$ & Chr$(13) & Chr$(13) & "Bereich: [Ablauf]" & Chr$(13) & "Eintrag: " & LTrim$(RTrim$(Str$(Count%))) & "=" & Item$ & Chr$(13) & Chr$(13) & "Syntax: [Lfd-Nr]=Disk_Anforderung [Disk-Nr]; [Identifikations-Dateiname]" & Chr$(13) & Chr$(13) & "Parameter [Disk-Nr] fehlt." & Chr$(13) & Chr$(13) & "Setup kann nicht fortgesetzt werden."
		GoTo ERR_ExecCmd_1
	    End If

	    If Param.i(2) = "" Then
		ShowErrorBox2 "Fehler in der Setup-INI-Datei " & SetupIniName$ & Chr$(13) & Chr$(13) & "Bereich: [Ablauf]" & Chr$(13) & "Eintrag: " & LTrim$(RTrim$(Str$(Count%))) & "=" & Item$ & Chr$(13) & Chr$(13) & "Syntax: [Lfd-Nr]=Disk_Anforderung [Disk-Nr]; [Identifikations-Dateiname]" & Chr$(13) & Chr$(13) & "Parameter [Identifikations-Dateiname] fehlt." & Chr$(13) & Chr$(13) & "Setup kann nicht fortgesetzt werden."
		GoTo ERR_ExecCmd_1
	    End If

LABEL_ExecCmd_1:

	    If Not PromptForNextDisk(CInt(Param.i(1)), Param.i(2)) Then
		If ShowYesNoBox(QuestionBoxCaption$, "Wollen Sie die Installation wirklich abbrechen?", 2) = IDYES Then
		    GoTo ERR_ExecCmd_1
		Else
		    GoTo LABEL_ExecCmd_1
		End If
	    End If

	' Syntax: [Lfd-Nr]=Erzeuge_Pfad [Pfadname]

	Case UCase$("Erzeuge_Pfad")

	    If Param.i(1) = "" Then
		ShowErrorBox2 "Fehler in der Setup-INI-Datei " & SetupIniName$ & Chr$(13) & Chr$(13) & "Bereich: [Ablauf]" & Chr$(13) & "Eintrag: " & LTrim$(RTrim$(Str$(Count%))) & "=" & Item$ & Chr$(13) & Chr$(13) & "Syntax: [Lfd-Nr]=Erzeuge_Pfad [Pfadname]" & Chr$(13) & Chr$(13) & "Parameter [Pfadname] fehlt." & Chr$(13) & Chr$(13) & "Setup kann nicht fortgesetzt werden."
		GoTo ERR_ExecCmd_1
	    End If

	    If Not CreatePath(Param.i(1)) Then
		If ShowYesNoBox(QuestionBoxCaption$, "Soll das Setup-Programm beendet werden?", 2) = IDYES Then
		    GoTo ERR_ExecCmd_1
		End If
	    End If

	' Syntax: [Lfd-Nr]=Erzeuge_Zielpfad

	Case UCase$("Erzeuge_Zielpfad")

	    If Not CreatePath(DestPath$) Then
		If ShowYesNoBox(QuestionBoxCaption$, "Soll das Setup-Programm beendet werden?", 2) = IDYES Then
		    GoTo ERR_ExecCmd_1
		End If
	    End If

	' Syntax: [Lfd-Nr]=Erzeuge_Pfad_in_Zielpfad [Pfadname]

	' Anmerkung: Pfadname darf nicht mit "\" beginnen

	Case UCase$("Erzeuge_Pfad_in_Zielpfad")

	    If Param.i(1) = "" Then
		ShowErrorBox2 "Fehler in der Setup-INI-Datei " & SetupIniName$ & Chr$(13) & Chr$(13) & "Bereich: [Ablauf]" & Chr$(13) & "Eintrag: " & LTrim$(RTrim$(Str$(Count%))) & "=" & Item$ & Chr$(13) & Chr$(13) & "Syntax: [Lfd-Nr]=Erzeuge_Pfad_in_Zielpfad [Pfadname]" & Chr$(13) & Chr$(13) & "Parameter [Pfadname] fehlt." & Chr$(13) & Chr$(13) & "Setup kann nicht fortgesetzt werden."
		GoTo ERR_ExecCmd_1
	    End If

	    If Not CreatePath(DestPath$ & Param.i(1)) Then
		If ShowYesNoBox(QuestionBoxCaption$, "Soll das Setup-Programm beendet werden?", 2) = IDYES Then
		    GoTo ERR_ExecCmd_1
		End If
	    End If

	' Syntax: [Lfd-Nr]=Zeige_Status_Fenster_an [Kopfzeile]; [Gesamt Bytes]

	Case UCase$("Zeige_Status_Fenster_an")

	    ShowStatusDialog Param.i(1), CLng(Param.i(2))

	' Syntax: [Lfd-Nr]=Blende_Status_Fenster_aus

	Case UCase$("Blende_Status_Fenster_aus")

	    HideStatusDialog

	' Syntax: [Lfd-Nr]=Kopiere_Datei [Quellpfad]; [Quell-Dateiname]; [Zielpfad]; [Ziel-Dateiname]

	Case UCase$("Kopiere_Datei")

	    If Param.i(1) = "" Then
		ShowErrorBox2 "Fehler in der Setup-INI-Datei " & SetupIniName$ & Chr$(13) & Chr$(13) & "Bereich: [Ablauf]" & Chr$(13) & "Eintrag: " & LTrim$(RTrim$(Str$(Count%))) & "=" & Item$ & Chr$(13) & Chr$(13) & "Syntax: [Lfd-Nr]=Kopiere_Datei [Quellpfad]; [Quell-Dateiname]; [Zielpfad]; [Ziel-Dateiname]" & Chr$(13) & Chr$(13) & "Parameter [Quellpfad] fehlt." & Chr$(13) & Chr$(13) & "Setup kann nicht fortgesetzt werden."
		GoTo ERR_ExecCmd_1
	    End If

	    If Param.i(2) = "" Then
		ShowErrorBox2 "Fehler in der Setup-INI-Datei " & SetupIniName$ & Chr$(13) & Chr$(13) & "Bereich: [Ablauf]" & Chr$(13) & "Eintrag: " & LTrim$(RTrim$(Str$(Count%))) & "=" & Item$ & Chr$(13) & Chr$(13) & "Syntax: [Lfd-Nr]=Kopiere_Datei [Quellpfad]; [Quell-Dateiname]; [Zielpfad]; [Ziel-Dateiname]" & Chr$(13) & Chr$(13) & "Parameter [Quell-Dateiname] fehlt." & Chr$(13) & Chr$(13) & "Setup kann nicht fortgesetzt werden."
		GoTo ERR_ExecCmd_1
	    End If

	    If Param.i(3) = "" Then
		ShowErrorBox2 "Fehler in der Setup-INI-Datei " & SetupIniName$ & Chr$(13) & Chr$(13) & "Bereich: [Ablauf]" & Chr$(13) & "Eintrag: " & LTrim$(RTrim$(Str$(Count%))) & "=" & Item$ & Chr$(13) & Chr$(13) & "Syntax: [Lfd-Nr]=Kopiere_Datei [Quellpfad]; [Quell-Dateiname]; [Zielpfad]; [Ziel-Dateiname]" & Chr$(13) & Chr$(13) & "Parameter [Zielpfad] fehlt." & Chr$(13) & Chr$(13) & "Setup kann nicht fortgesetzt werden."
		GoTo ERR_ExecCmd_1
	    End If

	    If Param.i(4) = "" Then
		ShowErrorBox2 "Fehler in der Setup-INI-Datei " & SetupIniName$ & Chr$(13) & Chr$(13) & "Bereich: [Ablauf]" & Chr$(13) & "Eintrag: " & LTrim$(RTrim$(Str$(Count%))) & "=" & Item$ & Chr$(13) & Chr$(13) & "Syntax: [Lfd-Nr]=Kopiere_Datei [Quellpfad]; [Quell-Dateiname]; [Zielpfad]; [Ziel-Dateiname]" & Chr$(13) & Chr$(13) & "Parameter [Ziel-Dateiname] fehlt." & Chr$(13) & Chr$(13) & "Setup kann nicht fortgesetzt werden."
		GoTo ERR_ExecCmd_1
	    End If

LABEL_ExecCmd_2:

	    If Not CopyFile(Param.i(1), Param.i(3), Param.i(2), Param.i(4)) Then

LABEL_ExecCmd_3:

		Result% = ShowYesNoCancelBox(QuestionBoxCaption$, "Datei " & UCase$(Param.i(1)) & "\" & UCase$(Param.i(2)) & " konnte nicht kopiert werden." & Chr$(13) & Chr$(13) & "Nochmal versuchen?", 1)
		Select Case Result%
		    Case IDYES
			GoTo LABEL_ExecCmd_2
		    Case IDCANCEL
			If ShowYesNoBox(QuestionBoxCaption$, "Wollen Sie die Installation wirklich abbrechen?", 2) = IDYES Then
			    GoTo ERR_ExecCmd_1
			Else
			    GoTo LABEL_ExecCmd_3
			End If
		End Select
	    End If

	' Syntax: [Lfd-Nr]=Kopiere_Datei_in_Zielpfad [Quell-Dateiname]; [Unterverzeichnis in Zielpfad]; [Ziel-Dateiname]

	' Anmerkung: Name des Unterverzeichnisses im Zielpfad darf nicht mit "\" beginnen

	Case UCase$("Kopiere_Datei_in_Zielpfad")

	    If Param.i(1) = "" Then
		ShowErrorBox2 "Fehler in der Setup-INI-Datei " & SetupIniName$ & Chr$(13) & Chr$(13) & "Bereich: [Ablauf]" & Chr$(13) & "Eintrag: " & LTrim$(RTrim$(Str$(Count%))) & "=" & Item$ & Chr$(13) & Chr$(13) & "Syntax: [Lfd-Nr]=Kopiere_Datei_in_Zielpfad [Quell-Dateiname]; [Unterverzeichnis in Zielpfad]; [Ziel-Dateiname]" & Chr$(13) & Chr$(13) & "Parameter [Quell-Dateiname] fehlt." & Chr$(13) & Chr$(13) & "Setup kann nicht fortgesetzt werden."
		GoTo ERR_ExecCmd_1
	    End If

	    If Param.i(3) = "" Then
		ShowErrorBox2 "Fehler in der Setup-INI-Datei " & SetupIniName$ & Chr$(13) & Chr$(13) & "Bereich: [Ablauf]" & Chr$(13) & "Eintrag: " & LTrim$(RTrim$(Str$(Count%))) & "=" & Item$ & Chr$(13) & Chr$(13) & "Syntax: [Lfd-Nr]=Kopiere_Datei_in_Zielpfad [Quell-Dateiname]; [Unterverzeichnis in Zielpfad]; [Ziel-Dateiname]" & Chr$(13) & Chr$(13) & "Parameter [Ziel-Dateiname] fehlt." & Chr$(13) & Chr$(13) & "Setup kann nicht fortgesetzt werden."
		GoTo ERR_ExecCmd_1
	    End If

LABEL_ExecCmd_4:

	    If Not CopyFile(SrcPath$, DestPath$ & Param.i(2), Param.i(1), Param.i(3)) Then

LABEL_ExecCmd_5:

		Result% = ShowYesNoCancelBox(QuestionBoxCaption$, "Datei " & SrcPath$ & UCase$(Param.i(1)) & " konnte nicht kopiert werden." & Chr$(13) & Chr$(13) & "Nochmal versuchen?", 1)
		Select Case Result%
		    Case IDYES
			GoTo LABEL_ExecCmd_4
		    Case IDCANCEL
			If ShowYesNoBox(QuestionBoxCaption$, "Wollen Sie die Installation wirklich abbrechen?", 2) = IDYES Then
			    GoTo ERR_ExecCmd_1
			Else
			    GoTo LABEL_ExecCmd_5
			End If
		End Select
	    End If

	' Syntax: [Lfd-Nr]=Zeige_Program_Manager

	Case UCase$("Zeige_Program_Manager")

	    RestoreProgMan

	' Syntax: [Lfd-Nr]=Erzeuge_Programmgruppe [Name]; [Dateiname]

	Case UCase$("Erzeuge_Programmgruppe")

	    If Param.i(1) = "" Then
		ShowErrorBox2 "Fehler in der Setup-INI-Datei " & SetupIniName$ & Chr$(13) & Chr$(13) & "Bereich: [Ablauf]" & Chr$(13) & "Eintrag: " & LTrim$(RTrim$(Str$(Count%))) & "=" & Item$ & Chr$(13) & Chr$(13) & "Syntax: [Lfd-Nr]=Erzeuge_Programmgruppe [Name]; [Dateiname]" & Chr$(13) & Chr$(13) & "Parameter [Name] fehlt." & Chr$(13) & Chr$(13) & "Setup kann nicht fortgesetzt werden."
		GoTo ERR_ExecCmd_1
	    End If

	    If Param.i(2) = "" Then
		ShowErrorBox2 "Fehler in der Setup-INI-Datei " & SetupIniName$ & Chr$(13) & Chr$(13) & "Bereich: [Ablauf]" & Chr$(13) & "Eintrag: " & LTrim$(RTrim$(Str$(Count%))) & "=" & Item$ & Chr$(13) & Chr$(13) & "Syntax: [Lfd-Nr]=Erzeuge_Programmgruppe [Name]; [Dateiname]" & Chr$(13) & Chr$(13) & "Parameter [Dateiname] fehlt." & Chr$(13) & Chr$(13) & "Setup kann nicht fortgesetzt werden."
		GoTo ERR_ExecCmd_1
	    End If

	    CreateProgManGroup frm_Setup2, Param.i(1), Param.i(2)

	' Syntax: [Lfd-Nr]=Erzeuge_Programm_Icon [Kommando-String]; [Icon-Name]; [Kommando-String auf Zielpfad bezogen=J|N]

	' Anmerkung: Parameter "Kommando-String" bezieht sich auf den Zielpfad, wenn der Parameter "Kommando-String auf Zielpfad bezogen" auf "J" eingestellt ist
	'            Beispiel: Zielpfad        = C:\TEST\
	'                      Kommando-String = DATEN\TEST.DAT
	'                      Aufruf-Kommando = C:\TEST\DATEN\TEST.DAT

	Case UCase$("Erzeuge_Programm_Icon")

	    If Param.i(1) = "" Then
		ShowErrorBox2 "Fehler in der Setup-INI-Datei " & SetupIniName$ & Chr$(13) & Chr$(13) & "Bereich: [Ablauf]" & Chr$(13) & "Eintrag: " & LTrim$(RTrim$(Str$(Count%))) & "=" & Item$ & Chr$(13) & Chr$(13) & "Syntax: [Lfd-Nr]=Erzeuge_Programm_Icon [Kommando-String]; [Icon-Name]; [Kommando-String auf Zielpfad bezogen=J|N]" & Chr$(13) & Chr$(13) & "Parameter [Kommando-String] fehlt." & Chr$(13) & Chr$(13) & "Setup kann nicht fortgesetzt werden."
		GoTo ERR_ExecCmd_1
	    End If

	    If Param.i(2) = "" Then
		ShowErrorBox2 "Fehler in der Setup-INI-Datei " & SetupIniName$ & Chr$(13) & Chr$(13) & "Bereich: [Ablauf]" & Chr$(13) & "Eintrag: " & LTrim$(RTrim$(Str$(Count%))) & "=" & Item$ & Chr$(13) & Chr$(13) & "Syntax: [Lfd-Nr]=Erzeuge_Programm_Icon [Kommando-String]; [Icon-Name]; [Kommando-String auf Zielpfad bezogen=J|N]" & Chr$(13) & Chr$(13) & "Parameter [Icon-Name] fehlt." & Chr$(13) & Chr$(13) & "Setup kann nicht fortgesetzt werden."
		GoTo ERR_ExecCmd_1
	    End If

	    If UCase$(Param.i(3)) = "J" Then
		CreateProgManItem frm_Setup2, DestPath$ & Param.i(1), Param.i(2)
	    Else
		CreateProgManItem frm_Setup2, Param.i(1), Param.i(2)
	    End If

	' Syntax: [Lfd-Nr]=Rufe_Shell_auf [Kommando-String]

	Case UCase$("Rufe_Shell_auf")

	    If Param.i(1) = "" Then
		ShowErrorBox2 "Fehler in der Setup-INI-Datei " & SetupIniName$ & Chr$(13) & Chr$(13) & "Bereich: [Ablauf]" & Chr$(13) & "Eintrag: " & LTrim$(RTrim$(Str$(Count%))) & "=" & Item$ & Chr$(13) & Chr$(13) & "Syntax: [Lfd-Nr]=Rufe_Shell_auf [Kommando-String]" & Chr$(13) & Chr$(13) & "Parameter [Kommando-String] fehlt." & Chr$(13) & Chr$(13) & "Setup kann nicht fortgesetzt werden."
		GoTo ERR_ExecCmd_1
	    End If

	    If Not RunShell(Param.i(1)) Then
		ShowErrorBox2 "Kommandozeile " & Param.i(1) & " konnte nicht ausgefhrt werden (Shell-Aufruf)."
	    End If

	' Syntax: [Lfd-Nr]=Entpacke_LHARC_EXE [Dateiname]; [Unterverzeichnis in Zielpfad]; [Lschen=J|N]

	' Anmerkung: Die zu enkomprimierende Datei mu sich im Zielpfad (Hauptverzeichnis) oder in einem Unterverzeichnis befinden.
	'            Die Datei UNPACK.PIF mu sich im Windows-Hauptverzeichnis befinden.
	'            Name des Unterverzeichnisses im Zielpfad darf nicht mit "\" beginnen.

	Case UCase$("Entpacke_LHARC_EXE")

	    If Param.i(1) = "" Then
		ShowErrorBox2 "Fehler in der Setup-INI-Datei " & SetupIniName$ & Chr$(13) & Chr$(13) & "Bereich: [Ablauf]" & Chr$(13) & "Eintrag: " & LTrim$(RTrim$(Str$(Count%))) & "=" & Item$ & Chr$(13) & Chr$(13) & "Syntax: [Lfd-Nr]=Entpacke_LHARC_EXE [Dateiname]; [Unterverzeichnis in Zielpfad]; [Lschen=J|N]" & Chr$(13) & Chr$(13) & "Parameter [Dateiname] fehlt." & Chr$(13) & Chr$(13) & "Setup kann nicht fortgesetzt werden."
		GoTo ERR_ExecCmd_1
	    End If

	    CurrDir$ = CurDir$

LABEL_ExecCmd_6:

	    If Param.i(2) = "" Then
		ChDir Left$(DestPath$, Len(DestPath$) - 1)
		Result% = RunShell(WinDir$ & "\UNPACK.PIF " & DestPath$ & Param.i(1))
	    Else
		ChDir DestPath$ & Param.i(2)
		Result% = RunShell(WinDir$ & "\UNPACK.PIF " & DestPath$ & Param.i(2) & "\" & Param.i(1))
	    End If

	    If Not Result% Then

LABEL_ExecCmd_7:

		Result% = ShowYesNoCancelBox(QuestionBoxCaption$, "Datei " & DestPath$ & Param.i(2) & "\" & Param.i(1) & " konnte nicht entpackt werden." & Chr$(13) & Chr$(13) & "Nochmal versuchen?", 1)
		Select Case Result%
		    Case IDYES
			GoTo LABEL_ExecCmd_6
		    Case IDCANCEL
			If ShowYesNoBox(QuestionBoxCaption$, "Wollen Sie die Installation wirklich abbrechen?", 2) = IDYES Then
			    ChDir CurrDir$
			    GoTo ERR_ExecCmd_1
			Else
			    GoTo LABEL_ExecCmd_7
			End If
		End Select
	    Else
		If UCase$(Param.i(3)) = "J" Then
		    Kill DestPath$ & Param.i(2) & "\" & Param.i(1)
		End If
		ChDir CurrDir$
	    End If

	' Syntax: [Lfd-Nr]=Fge_SHARE_ein [DOS-Pfad]; [Parameter]

	Case UCase$("Fge_SHARE_ein")

	    If Not AddShare(Param.i(1), Param.i(2)) Then
		ShowErrorBox2 "SHARE-Befehl konnte nicht in die AUTOEXEC.BAT-Datei eingefgt werden."
	    End If

	' Syntax: [Lfd_Nr]=Kopiere_Datei_in_Win_Pfad [Quell-Dateiname]; [Unterverzeichnis im Windows-Pfad]; [Ziel-Dateiname]
	'
	' Anmerkung: Name des Unterverzeichnisses im Windows-Pfad darf nicht mit "\" beginnen

	Case UCase$("Kopiere_Datei_in_Win_Pfad")

	    If Param.i(1) = "" Then
		ShowErrorBox2 "Fehler in der Setup-INI-Datei " & SetupIniName$ & Chr$(13) & Chr$(13) & "Bereich: [Ablauf]" & Chr$(13) & "Eintrag: " & LTrim$(RTrim$(Str$(Count%))) & "=" & Item$ & Chr$(13) & Chr$(13) & "Syntax: [Lfd-Nr]=Kopiere_Datei_in_Win_Pfad [Quell-Dateiname]; [Unterverzeichnis im Windows-Pfad]; [Ziel-Dateiname]" & Chr$(13) & Chr$(13) & "Parameter [Quell-Dateiname] fehlt." & Chr$(13) & Chr$(13) & "Setup kann nicht fortgesetzt werden."
		GoTo ERR_ExecCmd_1
	    End If

	    If Param.i(3) = "" Then
		ShowErrorBox2 "Fehler in der Setup-INI-Datei " & SetupIniName$ & Chr$(13) & Chr$(13) & "Bereich: [Ablauf]" & Chr$(13) & "Eintrag: " & LTrim$(RTrim$(Str$(Count%))) & "=" & Item$ & Chr$(13) & Chr$(13) & "Syntax: [Lfd-Nr]=Kopiere_Datei_in_Win_Pfad [Quell-Dateiname]; [Unterverzeichnis im Windows-Pfad]; [Ziel-Dateiname]" & Chr$(13) & Chr$(13) & "Parameter [Ziel-Dateiname] fehlt." & Chr$(13) & Chr$(13) & "Setup kann nicht fortgesetzt werden."
		GoTo ERR_ExecCmd_1
	    End If

LABEL_ExecCmd_8:

	    If Not CopyFile(SrcPath$, WinDir$ & Param.i(2), Param.i(1), Param.i(3)) Then

LABEL_ExecCmd_9:

		Result% = ShowYesNoCancelBox(QuestionBoxCaption$, "Datei " & SrcPath$ & UCase$(Param.i(1)) & " konnte nicht kopiert werden." & Chr$(13) & Chr$(13) & "Nochmal versuchen?", 1)
		Select Case Result%
		    Case IDYES
			GoTo LABEL_ExecCmd_8
		    Case IDCANCEL
			If ShowYesNoBox(QuestionBoxCaption$, "Wollen Sie die Installation wirklich abbrechen?", 2) = IDYES Then
			    GoTo ERR_ExecCmd_1
			Else
			    GoTo LABEL_ExecCmd_9
			End If
		End Select
	    End If

	' Syntax: [Lfd-Nr]=Entpacke_LHARC_EXE_in_Win_Pfad [Dateiname]; [Unterverzeichnis im Windows-Pfad]; [Lschen=J|N]

	' Anmerkung: Die Datei UNPACK.PIF mu sich im Windows-Hauptverzeichnis befinden.
	'            Name des Unterverzeichnisses im Windows-Pfad darf nicht mit "\" beginnen.

	Case UCase$("Entpacke_LHARC_EXE_in_Win_Pfad")

	    If Param.i(1) = "" Then
		ShowErrorBox2 "Fehler in der Setup-INI-Datei " & SetupIniName$ & Chr$(13) & Chr$(13) & "Bereich: [Ablauf]" & Chr$(13) & "Eintrag: " & LTrim$(RTrim$(Str$(Count%))) & "=" & Item$ & Chr$(13) & Chr$(13) & "Syntax: [Lfd-Nr]=Entpacke_LHARC_EXE_in_Win_Pfad [Dateiname]; [Unterverzeichnis im Windows-Pfad]; [Lschen=J|N]" & Chr$(13) & Chr$(13) & "Parameter [Dateiname] fehlt." & Chr$(13) & Chr$(13) & "Setup kann nicht fortgesetzt werden."
		GoTo ERR_ExecCmd_1
	    End If

	    CurrDir$ = CurDir$

LABEL_ExecCmd_10:

	    If Param.i(2) = "" Then
		ChDir Left$(WinDir$, Len(WinDir$) - 1)
		Result% = RunShell(WinDir$ & "\UNPACK.PIF " & WinDir$ & Param.i(1))
	    Else
		ChDir WinDir$ & Param.i(2)
		Result% = RunShell(WinDir$ & "\UNPACK.PIF " & WinDir$ & Param.i(2) & "\" & Param.i(1))
	    End If

	    If Not Result% Then

LABEL_ExecCmd_11:

		Result% = ShowYesNoCancelBox(QuestionBoxCaption$, "Datei " & WinDir$ & Param.i(2) & "\" & Param.i(1) & " konnte nicht entpackt werden." & Chr$(13) & Chr$(13) & "Nochmal versuchen?", 1)
		Select Case Result%
		    Case IDYES
			GoTo LABEL_ExecCmd_10
		    Case IDCANCEL
			If ShowYesNoBox(QuestionBoxCaption$, "Wollen Sie die Installation wirklich abbrechen?", 2) = IDYES Then
			    ChDir CurrDir$
			    GoTo ERR_ExecCmd_1
			Else
			    GoTo LABEL_ExecCmd_11
			End If
		End Select
	    Else
		If UCase$(Param.i(3)) = "J" Then
		    Kill WinDir$ & Param.i(2) & "\" & Param.i(1)
		End If
		ChDir CurrDir$
	    End If

    End Select

    If Err = 0 Then ExecCmd = True

EXIT_ExecCmd:

    Exit Function

ERR_ExecCmd_1:

    ChDrive WinDrive$
    ChDir Left$(WinDir$, Len(WinDir$) - 1)
    End
    GoTo EXIT_ExecCmd

End Function

'============================================================
' Routine : FileExists
'============================================================
' Aufgabe : Liefert True zurck, wenn die angegebene Datei
'           existiert, sonst False.
' Eingabe : FileName = Dateiname inkl. Pfadangabe
' Ausgabe : keine
' Return  : True bzw. False
'------------------------------------------------------------
'
Function FileExists (FileName$) As Integer

    Dim x

    x = FreeFile

    On Error Resume Next

    Open FileName$ For Input As x

    If Err = 0 Then
	FileExists = True
    Else
	FileExists = False
    End If

    Close x

End Function

'============================================================
' Routine : GetDiskSpaceFree
'============================================================
' Aufgabe : Liefert die Gre des vorhandenen Speicherplatzes
'           eines Laufwerkes zurck.
' Eingabe : drive = Laufwerksbezeichnung
' Ausgabe : keine
' Return  : Gre des vorhandenen Speicherplatzes
'------------------------------------------------------------
'
Function GetDiskSpaceFree (drive$) As Long

    ChDrive drive
    GetDiskSpaceFree = DiskSpaceFree()

End Function

'============================================================
' Routine : GetFileSize
'============================================================
' Aufgabe : Liefert die Gre einer Datei zurck.
' Eingabe : FileName = Dateiname
' Ausgabe : keine
' Return  : Dateigre
'------------------------------------------------------------
'
Function GetFileSize (FileName$) As Long

    Dim x

    x = FreeFile
    Open FileName$ For Binary Access Read As x
    GetFileSize = LOF(x)
    Close x

End Function

'============================================================
' Routine : GetFileVersion
'============================================================
' Aufgabe : Liefert die Versionsnummer einer Datei zurck.
' Eingabe : FileToCheck = Dateiname
' Ausgabe : keine
' Return  : Versionsnummer (Parameter vom Typ String)
'------------------------------------------------------------
'
Function GetFileVersion (FileToCheck$) As String

    Dim lpdwHandle&
    Dim VersionInfoSize&
    Dim lpvdata$
    Dim VersionInfo%
    Dim lplpBuffer&
    Dim lpcb%
    Dim ptrFixed%
    Dim TransString$
    Dim ptrString%
    Dim fixedstr$
    Dim stringcopy&
    Dim i
    Dim char$
    Dim nextchar$
    Dim TransValue&
    Dim TransTable$

    On Error Resume Next

    VersionInfoSize& = GetFileVersionInfoSize(FileToCheck, lpdwHandle&)
    If VersionInfoSize& = 0 Then
	GetFileVersion = ""
	Exit Function
    End If
    lpvdata$ = String(VersionInfoSize&, Chr$(0))
    VersionInfo% = GetFileVersionInfo(FileToCheck, lpdwHandle&, VersionInfoSize&, lpvdata$)
    ptrFixed% = VerQueryValue(lpvdata$, "\FILEVERSION", lplpBuffer&, lpcb%)
    If ptrFixed% = 0 Then
	TransString$ = "040904E4"
	ptrString% = VerQueryValue(lpvdata$, "\StringFileInfo\" & TransString$ & "\CompanyName", lplpBuffer&, lpcb%)
	If ptrString% <> 0 Then GoTo GetValues
	ptrFixed% = VerQueryValue(lpvdata$, "\", lplpBuffer&, lpcb%)
	If ptrFixed% = 0 Then
	    GetFileVersion = ""
	    Exit Function
	Else
	    TransString$ = ""
	    fixedstr$ = String(lpcb% + 1, Chr(0))
	    stringcopy& = lstrcpyn(fixedstr$, lplpBuffer&, lpcb% + 1)
	    For i = lpcb% To 1 Step -1
		char$ = Hex(Asc(Mid(fixedstr$, i, 1)))
		If Len(char$) = 1 Then
		    char$ = "0" + char$
		End If
		TransString$ = TransString$ + char$
		If Len(TransString$ & nextchar$) Mod 8 = 0 Then
		    TransString$ = "&H" & TransString$
		    TransValue& = Val(TransString$)
		    TransString$ = ""
		End If
	    Next i
	End If
    End If
    TransTable$ = String(lpcb% + 1, Chr(0))
    TransString$ = String(0, Chr(0))
    stringcopy& = lstrcpyn(TransTable$, lplpBuffer&, lpcb% + 1)
    For i = 1 To lpcb%
	char$ = Hex(Asc(Mid(TransTable$, i, 1)))
	If Len(char$) = 1 Then
	    char$ = "0" + char$
	End If
	If Len(TransString$ & nextchar$) Mod 4 = 0 Then
	    nextchar$ = char$
	Else
	    TransString$ = TransString$ + char$ + nextchar$
	    nextchar$ = ""
	    char$ = ""
	End If
    Next i

GetValues:

    ptrString% = VerQueryValue(lpvdata$, "\StringFileInfo\" & TransString$ & "\FileVersion", lplpBuffer&, lpcb%)
    If ptrString% = 1 Then
	TransTable$ = String(lpcb%, Chr(0))
	stringcopy& = lstrcpyn(TransTable$, lplpBuffer&, lpcb% + 1)
	GetFileVersion = TransTable$
    Else
	GetFileVersion = ""
    End If

End Function

'============================================================
' Routine : GetIniString
'============================================================
' Aufgabe : Liefert einen String aus dem angegebenen Bereich
'           und dem angegebenen Eintrag in einer INI-Datei.
' Eingabe : Section  = Bereich
'           Item     = Eintrag
'           Default  = Standard-String
'           FileName = Name der INI-Datei
' Ausgabe : keine
' Return  : Parameter vom Typ String
'------------------------------------------------------------
'
Function GetIniString (Section$, Item$, Default$, FileName$) As String

    Const BufSize = 2048 ' max. Anzahl Zeichen im Puffer

    Dim Buffer$ ' Puffer fr den INI-String
    Dim CopyBytes% ' Anzahl der in den Puffer kopierten Zeichen

    GetIniString = Default$
    If FileName$ <> "" Then
	Buffer$ = String$(BufSize, 32) ' Puffer mit Leerzeichen fllen
	CopyBytes% = GetPrivateProfileString(Section$, Item$, Default$, Buffer$, Len(Buffer$), FileName$) ' INI-String auslesen
	If CopyBytes% > 0 Then GetIniString = Mid$(Buffer$, 1, CopyBytes%) ' Leerzeichen lschen
    End If

End Function

'============================================================
' Routine : GetWindowsDir
'============================================================
' Aufgabe : Liefert das Windows-Verzeichnis zurck.
' Eingabe : keine
' Ausgabe : keine
' Return  : Windows-Verzeichnis
'------------------------------------------------------------
'
Function GetWindowsDir () As String

    Dim temp$
    Dim x

    temp$ = String$(145, 0)
    x = GetWindowsDirectory(temp$, 145)
    temp$ = Left$(temp$, x)

    If Right$(temp$, 1) <> "\" Then
	GetWindowsDir$ = temp$ + "\"
    Else
	GetWindowsDir$ = temp$
    End If

End Function

'============================================================
' Routine : GetWindowsSysDir
'============================================================
' Aufgabe : Liefert das Windows-System-Verzeichnis zurck.
' Eingabe : keine
' Ausgabe : keine
' Return  : Windows-System-Verzeichnis
'------------------------------------------------------------
'
Function GetWindowsSysDir () As String

    Dim temp$
    Dim x

    temp$ = String$(145, 0)
    x = GetSystemDirectory(temp$, 145)
    temp$ = Left$(temp$, x)

    If Right$(temp$, 1) <> "\" Then
	GetWindowsSysDir$ = temp$ + "\"
    Else
	GetWindowsSysDir$ = temp$
    End If

End Function

'============================================================
' Routine : HideStatusDialog
'============================================================
' Aufgabe : Blendet das Status-Dialogfenster aus.
' Eingabe : keine
' Ausgabe : keine
'------------------------------------------------------------
'
Sub HideStatusDialog ()

    Unload frm_StatusDlg

End Sub

'============================================================
' Routine : InitParameters
'============================================================
' Aufgabe : Initialisiert globale Parameter.
' Eingabe : keine
' Ausgabe : keine
'------------------------------------------------------------
'
Sub InitParameters ()

    Dim Result%
    Dim temp$

    On Error Resume Next

    WinSysDir$ = UCase$(GetWindowsSysDir())
    WinDir$ = UCase$(GetWindowsDir())
    WinDrive$ = UCase$(Left$(WinDir$, 1)) & ":"
    If InStr(WinSysDir$, WinDir$) = 0 Then
	WinSysDir$ = WinDir$
    End If

    SetupIniName$ = WinDir$ & "SETUP2.INI"

    If FileExists(SetupIniName) Then

	AppName$ = GetIniString(UCase$("Global"), UCase$("App_Name"), "", SetupIniName)
	If Err <> 0 Then AppName$ = ""

	SetupName$ = GetIniString(UCase$("Global"), UCase$("Setup_Name"), "Setup", SetupIniName)
	If Err <> 0 Then SetupName$ = "Setup"

	WinSysNeeded& = CLng(GetIniString(UCase$("Global"), UCase$("Anzahl_Bytes_Windows"), "0", SetupIniName))
	If Err <> 0 Then WinSysNeeded& = 0

	OtherNeeded& = CLng(GetIniString(UCase$("Global"), UCase$("Anzahl_Bytes_Sonstiges"), "0", SetupIniName))
	If Err <> 0 Then OtherNeeded& = 0

	Compressed& = CLng(GetIniString(UCase$("Global"), UCase$("Anzahl_Bytes_Ges_Komprimiert"), "0", SetupIniName))
	If Err <> 0 Then Compressed& = 0

	temp$ = UCase$(GetIniString(UCase$("Global"), UCase$("OLE2_Benutzung"), "N", SetupIniName))
	If temp$ = "N" Then
	    fOLE2% = False
	Else
	    fOLE2% = True
	End If

	SetupDlgTitle$ = GetIniString(UCase$("Setup-Fenster"), UCase$("Setup_Titel"), "", SetupIniName)
	If Err <> 0 Then SetupDlgTitle$ = ""

	TitleForeColor& = CLng(GetIniString(UCase$("Setup-Fenster"), UCase$("Titel_Vordergrundfarbe"), Str$(&H80000005), SetupIniName))
	If Err <> 0 Then TitleForeColor& = &H80000005

	temp$ = UCase$(GetIniString(UCase$("Setup-Fenster"), UCase$("Titel_fett"), "N", SetupIniName))
	If temp$ = "N" Then
	    TitleFontBold% = False
	Else
	    TitleFontBold% = True
	End If

	temp$ = UCase$(GetIniString(UCase$("Setup-Fenster"), UCase$("Titel_kursiv"), "N", SetupIniName))
	If temp$ = "N" Then
	    TitleFontItalic% = False
	Else
	    TitleFontItalic% = True
	End If

	temp$ = UCase$(GetIniString(UCase$("Setup-Fenster"), UCase$("Titel_unterstrichen"), "N", SetupIniName))
	If temp$ = "N" Then
	    TitleFontUnderline% = False
	Else
	    TitleFontUnderline% = True
	End If

	TitleFontName$ = UCase$(GetIniString(UCase$("Setup-Fenster"), UCase$("Titel_Font_Name"), "MS Sans Serif", SetupIniName))
	If Err <> 0 Then TitleFontName$ = "MS Sans Serif"

	TitleFontSize# = CDbl(GetIniString(UCase$("Setup-Fenster"), UCase$("Titel_Font_Gre"), "24", SetupIniName))
	If Err <> 0 Then TitleFontSize# = 24

	SetupDlgBackColor& = CLng(GetIniString(UCase$("Setup-Fenster"), UCase$("Setup_Hintergrundfarbe"), Str$(&H808000), SetupIniName))
	If Err <> 0 Then SetupDlgBackColor& = &H808000

	SetupDlgIntro$ = GetIniString(UCase$("Setup-Fenster"), UCase$("Setup_Intro"), "", SetupIniName)
	If Err <> 0 Then SetupDlgIntro$ = ""
	SetupDlgIntro$ = WinDir$ + SetupDlgIntro$

	SetupIntroPosX% = CInt(GetIniString(UCase$("Setup-Fenster"), UCase$("Setup_Intro_PosX"), "12", SetupIniName))
	If Err <> 0 Then SetupIntroPosX% = 12

	SetupIntroPosY% = CInt(GetIniString(UCase$("Setup-Fenster"), UCase$("Setup_Intro_PosY"), "80", SetupIniName))
	If Err <> 0 Then SetupIntroPosY% = 80

	SetupIntroWidth% = CInt(GetIniString(UCase$("Setup-Fenster"), UCase$("Setup_Intro_Breite"), "609", SetupIniName))
	If Err <> 0 Then SetupIntroWidth% = 609

	SetupIntroHeight% = CInt(GetIniString(UCase$("Setup-Fenster"), UCase$("Setup_Intro_Hhe"), "353", SetupIniName))
	If Err <> 0 Then SetupIntroHeight% = 353

	ErrorBoxCaption$ = GetIniString(UCase$("Message-Boxen"), UCase$("Kopfzeile_Fehler_Box"), "Fehler", SetupIniName)
	If Err <> 0 Then ErrorBoxCaption$ = "Fehler"
	If SetupName$ <> "" Then
	    ErrorBoxCaption$ = SetupName$ & " - " & ErrorBoxCaption$
	End If

	CrErrorBoxCaption$ = GetIniString(UCase$("Message-Boxen"), UCase$("Kopfzeile_Kr_Fehler_Box"), "Kritischer Fehler", SetupIniName)
	If Err <> 0 Then CrErrorBoxCaption$ = "Kritischer Fehler"
	If SetupName$ <> "" Then
	    CrErrorBoxCaption$ = SetupName$ & " - " & CrErrorBoxCaption$
	End If

	InfoBoxCaption$ = GetIniString(UCase$("Message-Boxen"), UCase$("Kopfzeile_Info_Box"), "Hinweis", SetupIniName)
	If Err <> 0 Then InfoBoxCaption$ = "Hinweis"
	If SetupName$ <> "" Then
	    InfoBoxCaption$ = SetupName$ & " - " & InfoBoxCaption$
	End If

	QuestionBoxCaption$ = GetIniString(UCase$("Message-Boxen"), UCase$("Kopfzeile_Frage_Box"), "Frage", SetupIniName)
	If Err <> 0 Then QuestionBoxCaption$ = "Frage"
	If SetupName$ <> "" Then
	    QuestionBoxCaption$ = SetupName$ & " - " & QuestionBoxCaption$
	End If

	WarningBoxCaption$ = GetIniString(UCase$("Message-Boxen"), UCase$("Kopfzeile_Warnung_Box"), "Warnung", SetupIniName)
	If Err <> 0 Then WarningBoxCaption$ = "Warnung"
	If SetupName$ <> "" Then
	    WarningBoxCaption$ = SetupName$ & " - " & WarningBoxCaption$
	End If

	StatusTitle$ = GetIniString(UCase$("Status-Fenster"), UCase$("Status_Titel"), "Status", SetupIniName)
	If Err <> 0 Then StatusTitle$ = "Status"

	SrcDialogTitle$ = GetIniString(UCase$("Installation von"), UCase$("Dialog_Titel"), "Installation von ...", SetupIniName)
	If Err <> 0 Then SrcDialogTitle$ = "Installation von ..."

	SrcDialogInfo$ = GetIniString(UCase$("Installation von"), UCase$("Dialog_Info"), "Bitte geben Sie Laufwerk und Pfad ein, in dem sich das zu installierende Programm befindet.", SetupIniName)
	If Err <> 0 Then SrcDialogInfo$ = "Bitte geben Sie Laufwerk und Pfad ein, in dem sich das zu installierende Programm befindet."

	SrcPathLabel$ = GetIniString(UCase$("Installation von"), UCase$("Label_Quellpfad"), "Quellpfad:", SetupIniName)
	If Err <> 0 Then SrcPathLabel$ = "Quellpfad:"

	SrcDrive$ = GetIniString(UCase$("Installation von"), UCase$("Quell_Laufwerk"), "A:", SetupIniName)
	If Err <> 0 Then SrcDrive$ = "A:"
	SrcDrive$ = UCase$(SrcDrive$)

	SrcPath$ = GetIniString(UCase$("Installation von"), UCase$("Quell_Pfad"), "", SetupIniName)
	If Err <> 0 Or SrcPath$ = "" Then SrcPath$ = SrcDrive$ + "\"
	If Left$(SrcPath$, 1) = "\" Then
	    SrcPath$ = SrcDrive$ + SrcPath$
	ElseIf Len(SrcPath$) > 2 Then
	    If InStr(1, SrcPath$, ":") And InStr(2, SrcPath$, "\") Then
		SrcPath$ = Right$(SrcPath$, Len(SrcPath$) - 2)
		SrcPath$ = SrcDrive$ + SrcPath$
	    End If
	End If
	SrcPath$ = UCase$(SrcPath$)

	DestDialogTitle$ = GetIniString(UCase$("Installation nach"), UCase$("Dialog_Titel"), "Installation nach ...", SetupIniName)
	If Err <> 0 Then DestDialogTitle$ = "Installation nach ..."

	DestDialogInfo$ = GetIniString(UCase$("Installation nach"), UCase$("Dialog_Info"), "Bitte geben Sie Laufwerk und Pfad ein, wonach das Programm installiert werden soll.", SetupIniName)
	If Err <> 0 Then DestDialogInfo$ = "Bitte geben Sie Laufwerk und Pfad ein, wonach das Programm installiert werden soll."

	DestPathLabel$ = GetIniString(UCase$("Installation nach"), UCase$("Label_Zielpfad"), "Zielpfad:", SetupIniName)
	If Err <> 0 Then DestPathLabel$ = "Zielpfad:"

	DestDrive$ = GetIniString(UCase$("Installation nach"), UCase$("Ziel_Laufwerk"), "C:", SetupIniName)
	If Err <> 0 Then DestDrive$ = "C:"
	DestDrive$ = UCase$(DestDrive$)

	DestPath$ = GetIniString(UCase$("Installation nach"), UCase$("Ziel_Pfad"), "", SetupIniName)
	If Err <> 0 Or DestPath$ = "" Then DestPath$ = DestDrive$ + "\"
	If Left$(DestPath$, 1) = "\" Then
	    DestPath$ = DestDrive$ + DestPath$
	ElseIf Len(DestPath$) > 2 Then
	    If InStr(1, DestPath$, ":") And InStr(2, DestPath$, "\") Then
		DestPath$ = Right$(DestPath$, Len(DestPath$) - 2)
		DestPath$ = DestDrive$ + DestPath$
	    End If
	End If
	DestPath$ = UCase$(DestPath$)
	
    Else
	Result% = ShowMsgBox("SETUP - Fehler", "Datei " & SetupIniName & " nicht gefunden. Setup kann nicht ausgefhrt werden.", MB_OK + MB_ICONSTOP)
	End
    End If

End Sub

'============================================================
' Routine : InstallCtl3D
'============================================================
' Aufgabe : Installiert die Windows-Klasse zur 3D-Darstellung
'           von Message-Boxen und liefert True oder False zu-
'           rck, je nachdem, ob die Operation erfolgreich war
'           oder nicht.
' Eingabe : ProgName = Name des Programms
' Ausgabe : keine
' Return  : True oder False
'------------------------------------------------------------
'
Function InstallCtl3D (ProgName$) As Integer

    Dim Inst%, Result%

    On Error Resume Next

    InstallCtl3D = False
    Inst% = GetModuleHandle(ProgName)
    Result% = Ctl3DRegister(Inst%)
    Result% = Ctl3DAutoSubclass(Inst%)
    InstallCtl3D = Result%

End Function

'============================================================
' Routine : IsValidPath
'============================================================
' Aufgabe : berprft die Gltigkeit eines Pfades und liefert
'           True bzw. False zurck
' Eingabe : Path         = Pfad
'           DefaultDrive = Standard-Laufwerksbezeichnung
' Ausgabe : Path         = formatierter Pfad (Form: "X:\DIR\DIR\")
' Return  : True (Pfad gltig) bzw. False (Pfad ungltig)
'------------------------------------------------------------
'
Function IsValidPath (Path$, ByVal DefaultDrive$) As Integer

    Dim tmp$, temp$
    Dim drive$
    Dim legalChar$
    Dim BackPos, ForePos
    Dim i
    Dim periodPos, length

    On Error GoTo ERR_IsValidPath

    Path$ = RTrim$(LTrim$(Path$))

    If Right$(DefaultDrive$, 1) <> ":" Or Len(DefaultDrive$) <> 2 Then
	ShowErrorBox2 "Falsche oder fehlende Laufwerksbezeichnung." & Chr$(13) & Chr$(13) & "Die Laufwerksbezeichnung mu einen Laufwerksbuchstaben (z.B. 'C') und ':' enthalten (z.B. 'C:')"
	GoTo ERR_IsValidPath
    End If

    If Left$(Path$, 1) = "\" Then
	Path$ = DefaultDrive$ + Path$
    End If

    On Error Resume Next

    tmp$ = Dir$(Path$)
    If Err <> 0 Then
	GoTo ERR_IsValidPath
    End If

    If (InStr(Path$, "*") <> 0) GoTo ERR_IsValidPath
    If (InStr(Path$, "?") <> 0) GoTo ERR_IsValidPath
    If (InStr(Path$, " ") <> 0) GoTo ERR_IsValidPath

    If Mid$(Path$, 2, 1) <> Chr$(58) Then GoTo ERR_IsValidPath

    If Len(Path$) > 2 Then
	If Right$(Left$(Path$, 3), 1) <> "\" Then
	    Path$ = Left$(Path$, 2) + "\" + Right$(Path$, Len(Path$) - 2)
	End If
    End If

    drive$ = Left$(Path$, 1)
    ChDrive (drive$)                                                        ' Try to
    If Err <> 0 Then GoTo ERR_IsValidPath

    If Right$(Path$, 1) <> "\" Then
	Path$ = Path$ + "\"
    End If

    If Len(Path$) = 3 Then
	If Right$(Path$, 2) = ":\" Then
	    GoTo EXIT_IsValidPath
	End If
    End If

    If InStr(Path$, "\\") <> 0 Then GoTo ERR_IsValidPath

    legalChar$ = "!#$%&'()-0123456789@ABCDEFGHIJKLMNOPQRSTUVWXYZ^_`{}~."
    BackPos = 3
    ForePos = InStr(4, Path$, "\")

    Do
	temp$ = Mid$(Path$, BackPos + 1, ForePos - BackPos - 1)
	For i = 1 To Len(temp$)
	    If InStr(legalChar$, UCase$(Mid$(temp$, i, 1))) = 0 Then GoTo ERR_IsValidPath
	Next i
	periodPos = InStr(temp$, ".")
	length = Len(temp$)
	If periodPos = 0 Then
	    If length > 8 Then GoTo ERR_IsValidPath
	Else
	    If periodPos > 9 Then GoTo ERR_IsValidPath
	    If length > periodPos + 3 Then GoTo ERR_IsValidPath
	    If InStr(periodPos + 1, temp$, ".") <> 0 Then GoTo ERR_IsValidPath
	End If
	BackPos = ForePos
	ForePos = InStr(BackPos + 1, Path$, "\")
    Loop Until ForePos = 0

EXIT_IsValidPath:

    IsValidPath = True
    Exit Function

ERR_IsValidPath:

    IsValidPath = False
    Exit Function

End Function

'============================================================
' Routine : Main
'============================================================
' Aufgabe : Hauptroutine des Setup-Programms
' Eingabe : keine
' Ausgabe : keine
'------------------------------------------------------------
'
Sub Main ()

    Dim TheVerInfo&
    Dim WinVer&
    Dim Count%, temp$, Pos, i
    Dim Continue
    Dim Cmd$
    Dim Param_ As ParamType
    Dim Result%
    Dim Item$

    Static Param$(10)

    On Error GoTo ERR_Main_2

    ' Windows-Klasse zur 3D-Darstellung von Message-Boxen installieren

    Result% = InstallCtl3D("[]")

    ' Parameter initialisieren

    InitParameters

    ' Windows-Version ermitteln

    TheVerInfo& = GetVersion()
    WinVer& = TheVerInfo& And &HFFFF&
    If Val(Format$(WinVer& Mod 256) + "." + Format$(WinVer& \ 256)) >= 3.1 Then
	gfWin31% = True
    End If

    ' Wird OLE 2.0 benutzt? Wenn ja, dann wird Windows 3.1 oder hher bentigt.

    If fOLE2% And Not gfWin31% Then
	ShowInfoBox "Dieses Programm bentigt Windows 3.1 oder hher"
	GoTo ERR_Main_1
    End If

    ' Setup-Hauptfenster anzeigen

    ShowMainForm

    ' Installationsablauf

    Count% = 1
    Continue = True

    While Continue

	Cmd$ = ""

	temp$ = GetIniString("Ablauf", Str$(Count%), "", SetupIniName)
	Item$ = temp$
	If temp$ = "" Then Continue = False

	If temp$ <> "" Then
	    For i = 1 To 10
		Param$(i) = ""
	    Next i
	    Pos = InStr(1, temp$, " ")
	    If Pos = 0 Then
		Cmd$ = UCase$(RTrim$(LTrim$(temp$)))
		temp$ = ""
	    Else
		Cmd$ = UCase$(RTrim$(LTrim$(Left$(temp$, Pos - 1))))
		temp$ = RTrim$(LTrim$(Right$(temp$, Len(temp$) - Pos)))
		If temp$ <> "" Then
		    i = 1
		    While temp$ <> "" And i <= 10
			Pos = InStr(1, temp$, ";")
			If Pos = 0 Then
			    Param$(i) = RTrim$(LTrim$(temp$))
			    temp$ = ""
			Else
			    Param$(i) = RTrim$(LTrim$(Left$(temp$, Pos - 1)))
			    temp$ = RTrim$(LTrim$(Right$(temp$, Len(temp$) - Pos)))
			End If
			i = i + 1
		    Wend
		End If
	    End If

	    If Cmd$ <> "" Then
		For i = 1 To 10
		    Param_.i(i) = Param$(i)
		Next i
		Result% = ExecCmd(Cmd$, Param_, Count%, Item$)
	    End If

	End If

	Count% = Count% + 1

    Wend

EXIT_Main:

    frm_Setup2.Hide
    RestoreProgMan
    End
    Exit Sub

ERR_Main_1:

    EndProgram True

ERR_Main_2:

    Result% = ShowErrorBox("Fehler Nr. " & Str$(Err) & " aufgetreten.", 1)
    Select Case Result%
	Case IDRETRY
	    Resume
	Case IDIGNORE
	    Resume Next
	Case IDABORT
	    Exit Sub
    End Select

End Sub

'============================================================
' Routine : PromptForNextDisk
'============================================================
' Aufgabe : Fordert den Benutzer auf, eine neue Diskette ins
'           Laufwerk einzulegen und liefert True bzw. False
'           zurck, je nachdem, ob die Operation erfolgreich
'           war oder nicht.
' Eingabe : wDiskNum      = Diskettennummer
'           FileToLookFor = Name der Datei, anhand deren die
'                           richtige Diskette identifiziert
'                           werden kann
' Ausgabe : keine
' Return  : True bzw. False
'------------------------------------------------------------
'
Function PromptForNextDisk (wDiskNum%, FileToLookFor$) As Integer

    Dim Ready
    Dim temp$
    Dim x

    Ready = False

    On Error Resume Next

    FileToLookFor$ = SrcDrive$ + FileToLookFor$
    temp$ = Dir$(FileToLookFor$)
    If Err <> 0 Or Len(temp$) = 0 Then
	While Not Ready
	    Err = 0
	    Beep
	    x = ShowOkCancelBox(InfoBoxCaption, "Bitte Diskette #" + Format$(wDiskNum%) + " ins Laufwerk " + SrcDrive$ + " einlegen.", 1)
	    If x = 2 Then
		PromptForNextDisk = False
		GoTo EXIT_PromptForNextDisk
	    Else
		temp$ = Dir$(FileToLookFor$)
		If Err = 0 And Len(temp$) <> 0 Then
		    PromptForNextDisk = True
		    Ready = True
		End If
	    End If
	Wend
    Else
	PromptForNextDisk = True
    End If

EXIT_PromptForNextDisk:

End Function

'============================================================
' Routine : RestoreProgMan
'============================================================
' Aufgabe : Zeigt den 'Program Manager'.
' Eingabe : keine
' Ausgabe : keine
'------------------------------------------------------------
'
Sub RestoreProgMan ()

    On Error GoTo ERR_RestoreProgMan

    AppActivate "Program Manager"
    SendKeys "%{ }{Enter}", True

ERR_RestoreProgMan:

    Exit Sub

End Sub

'============================================================
' Routine : RunShell
'============================================================
' Aufgabe : Ruft ein externes Programm via Shell auf und lie-
'           fert True oder False, je nachdem, ob die Operation
'           erfolgreich war oder nicht.
' Eingabe : CmdLine = Kommandozeile
' Ausgabe : keine
' Return  : True bzw. False
'------------------------------------------------------------
'
Function RunShell (CmdLine$) As Integer

    Dim Hnd As Integer
    Dim Dummy As Integer

    On Error GoTo ERR_RunShell

    Screen.MousePointer = 11

    RunShell = True

    Hnd = Shell(CmdLine, 2)
    
    Do
	Dummy = DoEvents()
    Loop While GetModuleUsage(Hnd)

    Screen.MousePointer = 0

EXIT_RunShell:

    Exit Function

ERR_RunShell:

    RunShell = False
    Screen.MousePointer = 0
    GoTo EXIT_RunShell

End Function

'============================================================
' Routine : ShowMainForm
'============================================================
' Aufgabe : Zeigt das Hauptfenster des Setup-Programms an.
' Eingabe : keine
' Ausgabe : keine
'------------------------------------------------------------
'
Sub ShowMainForm ()

    Dim Result%

    On Error Resume Next

    Screen.MousePointer = 11

    frm_Setup2.Caption = SetupName
    frm_Setup2.lab_Title.Caption = SetupDlgTitle
    frm_Setup2.lab_Title.ForeColor = TitleForeColor
    frm_Setup2.lab_Title.FontBold = TitleFontBold
    frm_Setup2.lab_Title.FontItalic = TitleFontItalic
    frm_Setup2.lab_Title.FontUnderline = TitleFontUnderline
    frm_Setup2.lab_Title.FontName = TitleFontName
    frm_Setup2.lab_Title.FontSize = TitleFontSize
    frm_Setup2.BackColor = SetupDlgBackColor
    frm_Setup2.img_Intro.Picture = LoadPicture(SetupDlgIntro$)
    frm_Setup2.img_Intro.Left = SetupIntroPosX
    frm_Setup2.img_Intro.Top = SetupIntroPosY
    frm_Setup2.img_Intro.Width = SetupIntroWidth
    frm_Setup2.img_Intro.Height = SetupIntroHeight
    
    Screen.MousePointer = 0

    frm_Setup2.Show
    frm_Setup2.Refresh

End Sub

'============================================================
' Routine : ShowMessageDialog
'============================================================
' Aufgabe : Zeigt das Message-Dialogfenster an.
' Eingabe : Title = Kopfzeile
'           Msg   = Message
' Ausgabe : keine
'------------------------------------------------------------
'
Sub ShowMessageDialog (Title$, Msg$)

    On Error Resume Next

    Load frm_MessageDlg

    CenterForm frm_MessageDlg
    frm_MessageDlg.Caption = Title$
    frm_MessageDlg.lab_Message = Msg$

    frm_MessageDlg.Show
    frm_MessageDlg.Refresh

End Sub

'============================================================
' Routine : ShowPathDialog
'============================================================
' Aufgabe : Zeigt das Pfad-Dialogfenster an.
' Eingabe : Title        = Kopfzeile
'           Info         = Info-Text
'           PathLabel    = Pfad-Label
'           DafaultDrive = Standard-Laufwerksbezeichnung
'           DefaultText  = Standard-Text (Voreinstellung)
' Ausgabe : Path         = Pfadname
'           OutButton    = Status ("Continue" oder "Exit")
'------------------------------------------------------------
'
Sub ShowPathDialog (Title$, Info$, PathLabel$, DefaultDrive$, DefaultText$, Path$, OutButton$)

    On Error Resume Next

    Screen.MousePointer = 11

    Load frm_PathDlg

    frm_PathDlg.Caption = Title$
    frm_PathDlg.lab_Info = Info$
    frm_PathDlg.lab_Path = PathLabel$
    frm_PathDlg.lab_Drive = DefaultDrive$
    frm_PathDlg.txt_Path = DefaultText$
    frm_PathDlg.txt_Path.SelStart = 0
    frm_PathDlg.txt_Path.SelLength = Len(DefaultText$)
    CenterForm frm_PathDlg

    Screen.MousePointer = 0

    frm_PathDlg.Show 1

    Path$ = frm_PathDlg.lab_OutPath.Tag
    OutButton$ = frm_PathDlg.lab_OutButton.Tag
    Unload frm_PathDlg

End Sub

'============================================================
' Routine : ShowStatusDialog
'============================================================
' Aufgabe : Zeigt das Status-Dialogfenster an.
' Eingabe : Title      = Kopfzeile
'           TotalBytes = Gesamtanzahl der zu kopierenden Bytes
' Ausgabe : keine
'------------------------------------------------------------
'
Sub ShowStatusDialog (Title$, TotalBytes&)

    On Error Resume Next

    Load frm_StatusDlg

    frm_StatusDlg.Caption = Title$
    frm_StatusDlg.lab_Total.Tag = Str$(TotalBytes)
    position = 0
    CenterForm frm_StatusDlg

    frm_StatusDlg.Show
    frm_StatusDlg.Refresh

End Sub

'============================================================
' Routine : UpdateStatus
'============================================================
' Aufgabe : Aktualisiert die Status-Anzeige (Fortschritt-Balken).
' Eingabe : FileBytes = Anzahl der kopierten Bytes einer Datei
' Ausgabe : keine
'------------------------------------------------------------
'
Sub UpdateStatus (FileBytes&)

    Dim estTotal As Long
    Dim Txt$
    Dim r

    estTotal = Val(frm_StatusDlg.lab_Total.Tag)
    If estTotal = False Then
	estTotal = 10000000
    End If

    position = position + CSng((FileBytes / estTotal) * 100)
    If position > 100 Then
	position = 100
    End If
    frm_StatusDlg.pic_StatusBar2.Cls
    frm_StatusDlg.pic_StatusBar2.Line (0, 0)-((position * (frm_StatusDlg.pic_StatusBar2.ScaleWidth / 100)), frm_StatusDlg.pic_StatusBar2.ScaleHeight), QBColor(4), BF

    Txt$ = Format$(CLng(position)) + "%"
    frm_StatusDlg.pic_StatusBar2.CurrentX = (frm_StatusDlg.pic_StatusBar2.ScaleWidth - frm_StatusDlg.pic_StatusBar2.TextWidth(Txt$)) \ 2
    frm_StatusDlg.pic_StatusBar2.CurrentY = (frm_StatusDlg.pic_StatusBar2.ScaleHeight - frm_StatusDlg.pic_StatusBar2.TextHeight(Txt$)) \ 2
    frm_StatusDlg.pic_StatusBar2.Print Txt$

    r = BitBlt(frm_StatusDlg.pic_StatusBar1.hDC, 0, 0, frm_StatusDlg.pic_StatusBar2.ScaleWidth, frm_StatusDlg.pic_StatusBar2.ScaleHeight, frm_StatusDlg.pic_StatusBar2.hDC, 0, 0, SRCCOPY)

End Sub

